Only copy a commit if it has at least one nonidentical parent.
[gitweb.git] / git-subtree.sh
index 2dc99e82cd0aa3c23587c77dbe4eac76d355385b..90e22ad8be3952e5ef77492cb46a8850b61c10c6 100755 (executable)
@@ -8,13 +8,16 @@ if [ $# -eq 0 ]; then
     set -- -h
 fi
 OPTS_SPEC="\
-git subtree add <--prefix=prefix <commit>
-git subtree split [options...] <--prefix=prefix> <commit...>
-git subtree merge 
+git subtree add --prefix=<prefix> <commit>
+git subtree split [options...] --prefix=<prefix> <commit...>
+git subtree merge --prefix=<prefix> <commit>
+git subtree pull  --prefix=<prefix> <repository> <refspec...>
 --
 h,help        show the help
 q             quiet
 prefix=       the name of the subdir to split out
+ options for 'split'
+annotate=     add a prefix to commit message of new commits
 onto=         try connecting new tree to an existing one
 rejoin        merge the new branch back into HEAD
 ignore-joins  ignore prior --rejoin commits
@@ -28,6 +31,7 @@ command=
 onto=
 rejoin=
 ignore_joins=
+annotate=
 
 debug()
 {
@@ -53,6 +57,8 @@ while [ $# -gt 0 ]; do
        shift
        case "$opt" in
                -q) quiet=1 ;;
+               --annotate) annotate="$1"; shift ;;
+               --no-annotate) annotate= ;;
                --prefix) prefix="$1"; shift ;;
                --no-prefix) prefix= ;;
                --onto) onto="$1"; shift ;;
@@ -68,27 +74,29 @@ done
 command="$1"
 shift
 case "$command" in
-       add|merge) default= ;;
+       add|merge|pull) default= ;;
        split) default="--default HEAD" ;;
        *) die "Unknown command '$command'" ;;
 esac
 
-revs=$(git rev-parse $default --revs-only "$@") || exit $?
-
 if [ -z "$prefix" ]; then
        die "You must provide the --prefix option."
 fi
 dir="$prefix"
 
-dirs="$(git rev-parse --no-revs --no-flags "$@")" || exit $?
-if [ -n "$dirs" ]; then
-       die "Error: Use --prefix instead of bare filenames."
+if [ "$command" != "pull" ]; then
+       revs=$(git rev-parse $default --revs-only "$@") || exit $?
+       dirs="$(git rev-parse --no-revs --no-flags "$@")" || exit $?
+       if [ -n "$dirs" ]; then
+               die "Error: Use --prefix instead of bare filenames."
+       fi
 fi
 
 debug "command: {$command}"
 debug "quiet: {$quiet}"
 debug "revs: {$revs}"
 debug "dir: {$dir}"
+debug "opts: {$*}"
 debug
 
 cache_setup()
@@ -121,13 +129,23 @@ cache_set()
        echo "$newrev" >"$cachedir/$oldrev"
 }
 
+# if a commit doesn't have a parent, this might not work.  But we only want
+# to remove the parent from the rev-list, and since it doesn't exist, it won't
+# be there anyway, so do nothing in that case.
+try_remove_previous()
+{
+       if git rev-parse "$1^" >/dev/null 2>&1; then
+               echo "^$1^"
+       fi
+}
+
 find_existing_splits()
 {
        debug "Looking for prior splits..."
        dir="$1"
        revs="$2"
        git log --grep="^git-subtree-dir: $dir\$" \
-               --pretty=format:'%s%n%n%b%nEND' "$revs" |
+               --pretty=format:'%s%n%n%b%nEND' $revs |
        while read a b junk; do
                case "$a" in
                        git-subtree-mainline:) main="$b" ;;
@@ -136,7 +154,8 @@ find_existing_splits()
                                if [ -n "$main" -a -n "$sub" ]; then
                                        debug "  Prior: $main -> $sub"
                                        cache_set $main $sub
-                                       echo "^$main^ ^$sub^"
+                                       try_remove_previous "$main"
+                                       try_remove_previous "$sub"
                                        main=
                                        sub=
                                fi
@@ -149,6 +168,7 @@ copy_commit()
 {
        # We're doing to set some environment vars here, so
        # do it in a subshell to get rid of them safely later
+       debug copy_commit "{$1}" "{$2}" "{$3}"
        git log -1 --pretty=format:'%an%n%ae%n%ad%n%cn%n%ce%n%cd%n%s%n%n%b' "$1" |
        (
                read GIT_AUTHOR_NAME
@@ -163,7 +183,7 @@ copy_commit()
                        GIT_COMMITTER_NAME \
                        GIT_COMMITTER_EMAIL \
                        GIT_COMMITTER_DATE
-               (echo -n '*'; cat ) |  # FIXME
+               (echo -n "$annotate"; cat ) |
                git commit-tree "$2" $3  # reads the rest of stdin
        ) || die "Can't copy commit $1"
 }
@@ -238,37 +258,58 @@ copy_or_skip()
        assert [ -n "$tree" ]
 
        identical=
+       nonidentical=
        p=
+       gotparents=
        for parent in $newparents; do
                ptree=$(toptree_for_commit $parent) || exit $?
+               [ -z "$ptree" ] && continue
                if [ "$ptree" = "$tree" ]; then
                        # an identical parent could be used in place of this rev.
                        identical="$parent"
+               else
+                       nonidentical="$parent"
                fi
-               if [ -n "$ptree" ]; then
-                       parentmatch="$parentmatch$parent"
+               
+               # sometimes both old parents map to the same newparent;
+               # eliminate duplicates
+               is_new=1
+               for gp in $gotparents; do
+                       if [ "$gp" = "$parent" ]; then
+                               is_new=
+                               break
+                       fi
+               done
+               if [ -n "$is_new" ]; then
+                       gotparents="$gotparents $parent"
                        p="$p -p $parent"
                fi
        done
        
-       if [ -n "$identical" -a "$parentmatch" = "$identical" ]; then
+       if [ -n "$identical" -a -z "$nonidentical" ]; then
                echo $identical
        else
                copy_commit $rev $tree "$p" || exit $?
        fi
 }
 
-cmd_add()
+ensure_clean()
 {
-       if [ -e "$dir" ]; then
-               die "'$dir' already exists.  Cannot add."
-       fi
        if ! git diff-index HEAD --exit-code --quiet; then
                die "Working tree has modifications.  Cannot add."
        fi
        if ! git diff-index --cached HEAD --exit-code --quiet; then
                die "Index has modifications.  Cannot add."
        fi
+}
+
+cmd_add()
+{
+       if [ -e "$dir" ]; then
+               die "'$dir' already exists.  Cannot add."
+       fi
+       ensure_clean
+       
        set -- $revs
        if [ $# -ne 1 ]; then
                die "You must provide exactly one revision.  Got: '$revs'"
@@ -313,9 +354,9 @@ cmd_split()
                unrevs="$(find_existing_splits "$dir" "$revs")"
        fi
        
-       # We can't restrict rev-list to only "$dir" here, because that leaves out
-       # critical information about commit parents.
-       debug "git rev-list --reverse --parents $revs $unrevs"
+       # We can't restrict rev-list to only $dir here, because some of our
+       # parents have the $dir contents the root, and those won't match.
+       # (and rev-list --follow doesn't seem to solve this)
        git rev-list --reverse --parents $revs $unrevs |
        while read rev parents; do
                debug
@@ -357,7 +398,22 @@ cmd_split()
 
 cmd_merge()
 {
-       die "merge command not implemented yet"
+       ensure_clean
+       
+       set -- $revs
+       if [ $# -ne 1 ]; then
+               die "You must provide exactly one revision.  Got: '$revs'"
+       fi
+       rev="$1"
+       
+       git merge -s subtree $rev
+}
+
+cmd_pull()
+{
+       ensure_clean
+       set -x
+       git pull -s subtree "$@"
 }
 
-"cmd_$command"
+"cmd_$command" "$@"